/* ioali.h */
/****************************************************************************/
/*
** I O A L I . H
**
**
** Yleiskyttisi IO-rutiineja mm. Kerho-ohjelman kyttn
** Liskommentit ks. IOALI.C
**
**  Tekijt:          Vesa Lappalainen
**                    Ohjelmointikurssi 1991-
**  Tehty:            20.12.1991
**  Muutettu:         15.12.1995/vl
**  Mit muutettu:    + siirrettty omaksi yleiskyttiseksi kirjoistoksi
**
**
*****************************************************************************/

#ifndef __IOALI_H
#define __IOALI_H

#ifdef __cplusplus
extern "C" {
#endif

/*----------------------------------------------------------------------------
** Vakiota:
----------------------------------------------------------------------------*/
#define MERKKI_ISOKSI   1
#define MYOS_PIENET     0
#define KAIKKI_KELPAA   NULL
#define EI_OLETUSTA     0
#define RIVINVAIHTO     "\r\n"


char lue_merkki(void);
char odota_nappain(const char *kelpaavat, char oletus,int merkki_isoksi);
void odota_jotakin(void);
void ei_toimi(void);
int kylla_vastaus(void);
void viiva(int pit, char merkki);
void viivarivi(int pit, char merkki);
void otsikko(char c,const char *teksti);
int ilmoitus(const char *s);
int kylla_kysymys(const char *s);
int onko_tiedostoa(const char *nimi);


#ifdef __cplusplus
}
#endif


#endif
